// LoveHammerDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "crystalcpuid.h"
#include "CrystalCPUIDDlg.h"
#include "LoveHammerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CCrystalCPUIDDlg* P;

/////////////////////////////////////////////////////////////////////////////
// CLoveHammerDlg _CAO


CLoveHammerDlg::CLoveHammerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoveHammerDlg::IDD, pParent)
{
	P = (CCrystalCPUIDDlg*)pParent;
	//{{AFX_DATA_INIT(CLoveHammerDlg)
	m_CurrentFID = _T("");
	m_CurrentVID = _T("");
	m_MaxFID = _T("");
	m_MaxVID = _T("");
	m_StartupFID = _T("");
	m_StartupVID = _T("");
	//}}AFX_DATA_INIT
}


void CLoveHammerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoveHammerDlg)
	DDX_Control(pDX, IDC_LH_VOLTAGE_MESSAGE, m_VoltageMessage);
	DDX_Control(pDX, IDC_LH_SET_VID, m_SetVID);
	DDX_Control(pDX, IDC_LH_SET_FID, m_SetFID);
	DDX_Text(pDX, IDC_LH_CURRENT_FID, m_CurrentFID);
	DDX_Text(pDX, IDC_LH_CURRENT_VID, m_CurrentVID);
	DDX_Text(pDX, IDC_LH_MAX_FID, m_MaxFID);
	DDX_Text(pDX, IDC_LH_MAX_VID, m_MaxVID);
	DDX_Text(pDX, IDC_LH_STARTUP_FID, m_StartupFID);
	DDX_Text(pDX, IDC_LH_STARTUP_VID, m_StartupVID);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLoveHammerDlg, CDialog)
	//{{AFX_MSG_MAP(CLoveHammerDlg)
	ON_CBN_SELCHANGE(IDC_LH_SET_FID, OnSelchangeLhSetFid)
	ON_CBN_SELCHANGE(IDC_LH_SET_VID, OnSelchangeLhSetVid)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoveHammerDlg bZ[W nh

void CLoveHammerDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CLoveHammerDlg::OnOK() 
{
	CDialog::OnOK();
}

void CLoveHammerDlg::Refresh()
{
	DWORD data;
	char str[256];

	// Init Current Status
	P->SysInfo->GetData(LH_GET_CURRENT_STATUS, &data);

	m_CurrentFID = P->SysInfo->GetInfo(LH_GET_CURRNET_MULTIPLIER,str);
	m_StartupFID = P->SysInfo->GetInfo(LH_GET_STARTUP_MULTIPLIER,str);
	m_MaxFID     = P->SysInfo->GetInfo(LH_GET_MAX_MULTIPLIER,str);

	m_CurrentVID = P->SysInfo->GetInfo(LH_GET_CURRNET_VOLTAGE,str);
	m_StartupVID = P->SysInfo->GetInfo(LH_GET_STARTUP_VOLTAGE,str);
	m_MaxVID     = P->SysInfo->GetInfo(LH_GET_MAX_VOLTAGE,str);

	UpdateData(FALSE);
	UpdateWindow();
}

BOOL CLoveHammerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CString cstr;
	double d;
	DWORD id = 0;
	DWORD type;
	DWORD data;

	// Init ComboBox
	P->SysInfo->GetData(LH_GET_TYPE, &type);
	if( type == 8 ){
		for(d = 4.0; d <= 25.0; d += 0.5){
			cstr.Format("x %.1f",d);
			m_SetFID.AddString(cstr);
		}
		
		for(d = 1.550; d >= 0.800; d -= 0.025){
			cstr.Format("%.3f V",d);
			m_SetVID.AddString(cstr);
		}
	}else if( type == 7 ){
		static BYTE MultiTableMobileAthlon[32]={22, 23, 24, 25, 10, 11, 12, 13, 
												14, 15, 16, 17, 18, 19, 20, 21,
												 6, 38,  8, 40, 26, 27, 28, 29, 
												30, 31, 32, 33, 34, 36, -1, -1};
		for(int i = 0; i < 30; i++ ){
			cstr.Format("x %.1f", MultiTableMobileAthlon[i] / 2.0 );
			m_SetFID.AddString(cstr);
		}
		m_VoltageMessage.EnableWindow(FALSE);
		m_SetVID.EnableWindow(FALSE);
	}

	// Init Current Status
	P->SysInfo->GetData(LH_GET_CURRENT_STATUS, &data);
	
	P->SysInfo->GetData(LH_GET_CURRNET_FID,&id);
	m_SetFID.SetCurSel(id);

	if( type == 8 ){
		P->SysInfo->GetData(LH_GET_CURRNET_VID,&id);
		m_SetVID.SetCurSel(id);
	}
	Refresh();

	return TRUE;
}

void CLoveHammerDlg::OnSelchangeLhSetFid() 
{
	P->SysInfo->SetData(LH_SET_FID,m_SetFID.GetCurSel());
	Refresh();
	P->Refresh(TRUE);
}

void CLoveHammerDlg::OnSelchangeLhSetVid() 
{
	P->SysInfo->SetData(LH_SET_VID,m_SetVID.GetCurSel());		
	Refresh();
}
